import { MockedComponent } from '../mock-component/types';
import { MockedDirective } from '../mock-directive/types';
import { MockedModule } from '../mock-module/types';
import { MockedPipe } from '../mock-pipe/types';
import { AnyType, Type } from './core.types';
/**
 * Returns a def of a mock module based on a mock module or a source module.
 *
 * @see https://ng-mocks.sudo.eu/api/helpers/getMockedNgDefOf
 */
export declare function getMockedNgDefOf<T>(declaration: AnyType<T>, type: 'm'): Type<MockedModule<T>>;
/**
 * Returns a def of a mock component based on a mock component or a source component.
 *
 * @see https://ng-mocks.sudo.eu/api/helpers/getMockedNgDefOf
 */
export declare function getMockedNgDefOf<T>(declaration: AnyType<T>, type: 'c'): Type<MockedComponent<T>>;
/**
 * Returns a def of a mock directive based on a mock directive or a source directive.
 *
 * @see https://ng-mocks.sudo.eu/api/helpers/getMockedNgDefOf
 */
export declare function getMockedNgDefOf<T>(declaration: AnyType<T>, type: 'd'): Type<MockedDirective<T>>;
/**
 * Returns a def of a mock pipe based on a mock pipe or a source pipe.
 *
 * @see https://ng-mocks.sudo.eu/api/helpers/getMockedNgDefOf
 */
export declare function getMockedNgDefOf<T>(declaration: AnyType<T>, type: 'p'): Type<MockedPipe<T>>;
/**
 * Returns a def of a mock class based on a mock class or a source class decorated by a ng type.
 *
 * @see https://ng-mocks.sudo.eu/api/helpers/getMockedNgDefOf
 */
export declare function getMockedNgDefOf(declaration: AnyType<any>): Type<any>;
