import { InjectionToken, Injector } from '@angular/core';
import { AbstractType, Type } from '../common/core.types';
/**
 * @see https://ng-mocks.sudo.eu/api/ngMocks/stubMember
 */
export declare function MockInstance<T extends object, K extends keyof T, S extends () => T[K]>(instance: Type<T> | AbstractType<T>, name: K, stub: S, encapsulation: 'get'): S;
/**
 * @see https://ng-mocks.sudo.eu/api/ngMocks/stubMember
 */
export declare function MockInstance<T extends object, K extends keyof T, S extends (value: T[K]) => void>(instance: Type<T> | AbstractType<T>, name: K, stub: S, encapsulation: 'set'): S;
/**
 * @see https://ng-mocks.sudo.eu/api/ngMocks/stubMember
 */
export declare function MockInstance<T extends object, K extends keyof T, S extends T[K]>(instance: Type<T> | AbstractType<T>, name: K, stub: S): S;
/**
 * @see https://ng-mocks.sudo.eu/api/MockInstance
 */
export declare function MockInstance<T>(declaration: InjectionToken<T>, init?: (instance: T | undefined, injector: Injector | undefined) => Partial<T>): void;
/**
 * @see https://ng-mocks.sudo.eu/api/MockInstance
 */
export declare function MockInstance<T>(declaration: InjectionToken<T>, config?: {
    init?: (instance: T | undefined, injector: Injector | undefined) => Partial<T>;
}): void;
/**
 * @see https://ng-mocks.sudo.eu/api/MockInstance
 */
export declare function MockInstance<T>(declaration: Type<T> | AbstractType<T>, init?: (instance: T, injector: Injector | undefined) => void | Partial<T>): void;
/**
 * @see https://ng-mocks.sudo.eu/api/MockInstance
 */
export declare function MockInstance<T>(declaration: Type<T> | AbstractType<T>, config?: {
    init?: (instance: T, injector: Injector | undefined) => void | Partial<T>;
}): void;
export declare function MockReset(): void;
